import {
  ACAttrFilter,
  ACGuard,
  ApiPaginatedResponse,
  diskStorage,
  PageDto,
  PageMetaDto,
  PageOptionsDto,
  pick,
  UserType,
} from '@gadmin2n/nest-common';
import {
  Body,
  Controller,
  Delete,
  Inject,
  NotFoundException,
  Param,
  ParseIntPipe,
  Patch,
  Post,
  Req,
  UploadedFile,
  UseGuards,
  UseInterceptors,
} from '@nestjs/common';
import {
  ApiCreatedResponse,
  ApiNotFoundResponse,
  ApiOkResponse,
  ApiTags,
} from '@nestjs/swagger';
import { Prisma } from '@prisma/client';
import { UseRoles } from 'nest-access-control';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import { CreateWorkflowNodeTypeDto } from '../../generated/workflowNodeType/dto/create-workflowNodeType.dto';
import { UpdateWorkflowNodeTypeDto } from '../../generated/workflowNodeType/dto/update-workflowNodeType.dto';
import {
  EffectedCount,
  UploudResponse,
  WorkflowNodeTypeFindManyArgs,
  WorkflowNodeTypeWhereSelect,
} from '../../generated/workflowNodeType/dto/workflowNodeType-types.dto';
import { WorkflowNodeTypeEntity } from '../../generated/workflowNodeType/entities/workflowNodeType.entity';
import { WorkflowNodeTypeService } from './workflowNodeType.service';

import { ConfigService } from '@nestjs/config';
import { FileInterceptor } from '@nestjs/platform-express';

@UseGuards(ACGuard)
@Controller('workflowNodeType')
@ApiTags('workflowNodeType')
export class WorkflowNodeTypeController {
  constructor(
    private readonly workflowNodeTypeService: WorkflowNodeTypeService,
    private readonly config: ConfigService,
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {}

  @Post('createOne')
  @UseRoles({
    resource: 'workflowNodeType',
    action: 'create',
    possession: 'any',
  })
  @ApiCreatedResponse({ type: WorkflowNodeTypeEntity })
  async createOne(
    @Body() body: CreateWorkflowNodeTypeDto,
    @ACAttrFilter() acAttrFilter,
    @Req() request: Request & { user: UserType },
  ) {
    body.creator = request.user.username;
    return new WorkflowNodeTypeEntity(
      await this.workflowNodeTypeService.createOne({
        data: acAttrFilter(body),
      }),
    );
  }

  @Post('findMany')
  @UseRoles({
    resource: 'workflowNodeType',
    action: 'read',
    possession: 'any',
  })
  @ApiPaginatedResponse(WorkflowNodeTypeEntity)
  async findMany(
    @Body() body: WorkflowNodeTypeFindManyArgs,
    @ACAttrFilter() acAttrFilter,
  ): Promise<PageDto<WorkflowNodeTypeEntity>> {
    const { itemCount, entities } = await this.workflowNodeTypeService.findMany(
      body as Prisma.WorkflowNodeTypeFindManyArgs,
    );
    const { skip = 0, take = 10 } = body as Prisma.WorkflowNodeTypeFindManyArgs;
    const pageOptionsDto: PageOptionsDto = { skip, take };
    const pageMetaDto = new PageMetaDto({ itemCount, pageOptionsDto });

    return new PageDto(
      entities.map((item) => new WorkflowNodeTypeEntity(acAttrFilter(item))),
      pageMetaDto,
    );
  }

  @Post('/findUnique/:id')
  @UseRoles({
    resource: 'workflowNodeType',
    action: 'read',
    possession: 'any',
  })
  @ApiOkResponse({ type: WorkflowNodeTypeEntity })
  @ApiNotFoundResponse({ description: 'Cannot found this record.' })
  async findUnique(
    @Param('id', ParseIntPipe) id: number,
    @Body() body: WorkflowNodeTypeWhereSelect,
    @ACAttrFilter() acAttrFilter,
  ) {
    const item = await this.workflowNodeTypeService.findUnique(id, body);
    if (!item) {
      throw new NotFoundException();
    }
    return new WorkflowNodeTypeEntity(acAttrFilter(item));
  }

  @Patch('updateUnique/:id')
  @UseRoles({
    resource: 'workflowNodeType',
    action: 'update',
    possession: 'any',
  })
  @ApiOkResponse({ type: WorkflowNodeTypeEntity })
  @ApiNotFoundResponse({ description: 'Cannot found this record.' })
  async updateUnique(
    @Param('id', ParseIntPipe) id: number,
    @Body() body: UpdateWorkflowNodeTypeDto,
    @ACAttrFilter() acAttrFilter,
  ) {
    /* 
    const origin = (await this.workflowNodeTypeService.findUnique(id, {
      id: true,
      // 这里需要根据实际情况填写
    })) as WorkflowNodeTypeEntity | null;
    if (!origin) {
      throw new NotFoundException();
    }
    // 需要兼容从列表页change_value入口进来的情况，这里进来的是只有少量字段的数据
    const newBody = {
      ...origin,
      ...body,
    };

    // 其他个性化逻辑
    */

    const item = await this.workflowNodeTypeService.updateUnique(
      id,
      acAttrFilter(body),
    );
    return new WorkflowNodeTypeEntity(acAttrFilter(item));
  }

  @Delete('deleteUnique/:id')
  @UseRoles({
    resource: 'workflowNodeType',
    action: 'delete',
    possession: 'any',
  })
  @ApiOkResponse({ type: EffectedCount })
  @ApiNotFoundResponse({ description: 'Cannot found this record.' })
  async deleteUnique(@Param('id', ParseIntPipe) id: number) {
    const res = await this.workflowNodeTypeService.deleteUnique(id);
    if (!res.count) {
      throw new NotFoundException();
    }
    return res;
  }

  @Post('upload')
  @UseRoles({
    resource: 'workflowNodeType',
    action: 'create',
    possession: 'any',
  })
  @ApiCreatedResponse({ type: UploudResponse })
  @UseInterceptors(FileInterceptor('file'))
  async uploadFile(@UploadedFile() file: Express.Multer.File) {
    const fileName = await diskStorage(
      file,
      this.config.get('media')['rootDir'] + '/workflowNodeType/',
    );

    return {
      ...pick(file, ['mimetype', 'originalname', 'size']),
      url:
        this.config.get('media')['address'] + '/workflowNodeType/' + fileName,
      name: fileName,
    };
  }
}
